Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.h	(revision 427)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssTree.h	(revision 434)
@@ -226,4 +226,8 @@
 		return mRay->GetOrigin(axis) + GetMaxT()*mRay->GetDir(axis);
 	}
+
+	Vector3 Extrap(const float t) const {
+		return mRay->Extrap(t);
+	}
 	
 #if USE_FIXEDPOINT_T
@@ -411,9 +415,13 @@
   
   RayInfoContainer rays;
+	int mPassingRays;
+	
 	bool mValidPvs;
+	
+	
 	
   VssTreeLeaf(VssTreeInterior *p,
 							const int nRays
-							):VssTreeNode(p), rays(), mPvsSize(0), mValidPvs(false) {
+							):VssTreeNode(p), rays(), mPvsSize(0), mPassingRays(0), mValidPvs(false) {
     rays.reserve(nRays);
   }
@@ -431,4 +439,6 @@
     rays.push_back(data);
     data.mRay->Ref();
+		if (data.GetRayClass() == RayInfo::PASSING_RAY)
+			mPassingRays++;
   }
 	
@@ -438,4 +448,5 @@
 	void SetPvsSize(const int s) {
 		mPvsSize = s;
+		mValidPvs = true;
 	}
 
@@ -537,5 +548,5 @@
 				leafb->rays.size()*b.bbox.GetVolume();
 #endif
-#if 1
+#if 0
 			return
 				leafa->GetPvsSize()*a.bbox.GetVolume()
@@ -555,5 +566,5 @@
 				leafb->GetPvsSize()/(leafb->rays.size()+1);
 #endif
-#if 0
+#if 1
 			return
 				leafa->GetPvsSize()*leafa->rays.size()
@@ -623,6 +634,11 @@
 
   // type of the splitting to use fo rthe tree construction
-  enum {ESplitRegular, ESplitHeuristic };
+  enum {ESplitRegular, ESplitHeuristic, ESplitHybrid };
   int splitType;
+
+	bool mSplitUseOnlyDrivingAxis;
+
+	// use ray space subdivision instead of view space subdivision
+	bool mUseRss;
 	
   // maximal size of the box on which the refdir splitting can be performed
@@ -723,26 +739,15 @@
   }
   
+
 	float
-	BestCostRatioHeuristic(
-												 VssTreeLeaf *node,
-												 int &axis,
-												 float &position,
-												 int &raysBack,
-												 int &raysFront,
-												 int &pvsBack,
-												 int &pvsFront
-												 );
-
-	float
-	BestCostRatioRegular(
-											 VssTreeLeaf *node,
-											 int &axis,
-											 float &position,
-											 int &raysBack,
-											 int &raysFront,
-											 int &pvsBack,
-											 int &pvsFront
-
-											 );
+	BestCostRatio(
+								VssTreeLeaf *node,
+								int &axis,
+								float &position,
+								int &raysBack,
+								int &raysFront,
+								int &pvsBack,
+								int &pvsFront
+								);
 	
 	float
@@ -757,5 +762,27 @@
 								);
 
-  AxisAlignedBox3 GetBBox(const VssTreeNode *node) {
+	float
+	EvalCostRatioHeuristic(
+												 VssTreeLeaf *node,
+												 const int axis,
+												 float &position,
+												 int &raysBack,
+												 int &raysFront,
+												 int &pvsBack,
+												 int &pvsFront
+												 );
+
+	float
+	GetCostRatio(
+							 VssTreeLeaf *leaf,
+							 const int axis,
+							 const float position,
+							 const int raysBack,
+							 const int raysFront,
+							 const int pvsBack,
+							 const int pvsFront
+							 );
+
+  AxisAlignedBox3 GetBBox(const VssTreeNode *node) const {
     if (node->parent == NULL)
       return bbox;
@@ -775,5 +802,5 @@
   }
 
-  AxisAlignedBox3 GetDirBBox(const VssTreeNode *node) {
+  AxisAlignedBox3 GetDirBBox(const VssTreeNode *node) const {
 
     if (node->parent == NULL)
@@ -834,9 +861,9 @@
 	int
 	GetRootPvsSize() const {
-		return GetPvsSize(root, bbox);
+		return GetPvsSize(bbox);
 	}
 	
 	int
-	GetPvsSize(VssTreeNode *node, const AxisAlignedBox3 &box) const;
+	GetPvsSize(const AxisAlignedBox3 &box) const;
 
 	void
@@ -874,5 +901,15 @@
 					);
 
-	
+	VssTreeNode *GetRoot() const { return root; }
+
+	bool
+	ValidLeaf(VssTreeLeaf *leaf) const;
+
+	void
+	GenerateLeafRays(VssTreeLeaf *leaf,
+									 const int numberOfRays,
+									 SimpleRayContainer &rays);
+
+
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 427)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 434)
@@ -1449,4 +1449,10 @@
   RegisterOption("VssTree.randomize", optBool, "randomize", "false");
   RegisterOption("VssTree.splitType", optString, "split=", "queries");
+  RegisterOption("VssTree.splitUseOnlyDrivingAxis", optBool, "splitdriving=", "false");
+
+  RegisterOption("VssTree.useRss", optBool, "rss=", "false");
+
+
+
   RegisterOption("VssTree.numberOfEndPointDomains", optInt, "endpoints=", "10000");
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h	(revision 428)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h	(revision 434)
@@ -19,4 +19,5 @@
 class BspLeaf;
 class Polygon3;
+class VssTree;
 
 class Exporter
@@ -47,4 +48,7 @@
   virtual bool
   ExportKdTree(const KdTree &tree) = 0;
+
+	virtual bool
+  ExportVssTree(const VssTree &tree) = 0;
 
   virtual bool
